//
//  ViewController.swift
//  comp7440
//
//  Created by saiho on 4/4/2019.
//  Copyright © 2019 saiho. All rights reserved.
//

import UIKit
import CoreLocation
import CoreMotion
import AVFoundation

class ViewController: UIViewController, CLLocationManagerDelegate {
    var mr = CMMotionManager()
    var aa=0
    var ab=0
    var ba=0
    var gc=0
    var hc=0
    var ibg = [Int]()
    var gg = [Double]()
    var seconds = 3
    var timer = Timer()
    var isTimerRunning = false
    var lm:CLLocationManager = CLLocationManager()
    @IBOutlet weak var lbltag: UILabel!
    @IBOutlet weak var lblf: UILabel!
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        lbltag.text=""
        lblf.text="falling down alarm."
        lm.delegate=self
        lm.requestAlwaysAuthorization()
    }
    
    func runTimer() {
        timer = Timer.scheduledTimer(timeInterval: 60, target: self, selector: (#selector(ViewController.updateTimer)), userInfo: nil, repeats: true)
    }
    @objc func updateTimer() {
        seconds -= 1
        isTimerRunning = true
        if seconds <= 0 { seconds=0
            self.makeAPhoneCall()
            self.timer.invalidate()
            
        }
        self.lbltag.text="\(seconds)"
    }
   
    override func viewDidAppear(_ animated: Bool) {
        mr.accelerometerUpdateInterval = 1
        mr.startAccelerometerUpdates(to: OperationQueue.current!, withHandler: { data, error in
            guard error == nil else { return }
            guard let accelerometerData = data else { return }
           var phone = abs(accelerometerData.acceleration.y * 10) / 9.8
            var hb = abs(accelerometerData.acceleration.x * 10) / 9.8
            var gb = abs(accelerometerData.acceleration.z * 10) / 9.8
            let yh = abs((hb + phone + gb) * 100) / 3
            //print(yh.rounded())
            var total = self.ibg.reduce(0, +)
            if total > 1 {
                if self.isTimerRunning==false{
            self.gc=self.gc+1
                    //print(self.gc)
            if self.gc>59 {
                self.gc=0
                self.hc=self.hc+1
            }
            
            if self.hc>14 {
                self.hc=0
                var maxVal = self.gg[0]
                var min = self.gg[0]
                for number in self.gg {
                    if maxVal < number { maxVal = number }
                    if min > number { min = number }
                }
                var gd = abs(maxVal - min)
              //  print(gd)
                if gd <= 3 {
                    self.view.backgroundColor=UIColor.red
                    for index in 1...10 {
                        let string = "Help me, I am something wrong!"
                        let utterance = AVSpeechUtterance(string: string)
                        utterance.voice = AVSpeechSynthesisVoice(language: "en-US")
                        
                        let synth = AVSpeechSynthesizer()
                        synth.speak(utterance)
                    }
                    self.makeAPhoneCall()
                }
                self.gg.removeAll()
            } else {
                self.gg.append(yh.rounded())
                    }
                }
            } else {
                self.gc=0
                self.hc=0
                self.gg.removeAll()
            }
        
            if (phone > 1) {
                phone = 1
            }
            if (phone < -1) {
                phone = -1
            }
            phone = (acos(phone) * 180) / Double.pi

            //print(phone)
            if total > 1 {
             if (phone > 35) {
                    if self.isTimerRunning == false {
                        self.lbltag.text = "\(self.seconds)"
                        self.runTimer()
                        
                        self.lblf.text="alarm triggering.."
                        self.lblf.highlightedTextColor=UIColor.red
                        // print(phone)
                    } else{
                        self.aa=1
                       var g:Int? = Int(self.lbltag.text!)
                        if g! > 0 {
                            g = g! - self.aa
                         }
                        if g == self.seconds {
                            self.view.backgroundColor=UIColor.yellow
                            for index in 1...10 {
                                let string = "Help me, I am falling down!"
                                let utterance = AVSpeechUtterance(string: string)
                                utterance.voice = AVSpeechSynthesisVoice(language: "en-US")
                                
                                let synth = AVSpeechSynthesizer()
                                synth.speak(utterance)
                            }
                         }
                    }
                  } else if (phone < 35) {
                if self.isTimerRunning==true{
                    self.lblf.text="falling down alarm."
                    self.lblf.highlightedTextColor=UIColor.black
                    self.seconds=3
                    self.lbltag.text = "\(self.seconds)"
                    self.timer.invalidate()
                }
            }
            }
            
            if self.ibg.count > 9 {
                self.ibg.removeAll()
            }
            
        })
    }
    func rangeib(){
        let uuid = UUID(uuidString: "FDA50693-A4E2-4FB1-AFCF-C6EB07647825")!
        let major:CLBeaconMajorValue = 8
        let minor:CLBeaconMinorValue = 1
        let idt = "HKBU"
        let pr = CLBeaconRegion(proximityUUID: uuid
            , major: major, minor: minor, identifier: idt)
        lm.startRangingBeacons(in: pr)
    }
    
    func locationManager(_ manager: CLLocationManager, didChangeAuthorization status: CLAuthorizationStatus) {
        if status == .authorizedAlways
        {
            rangeib()
        }
    }
    
    func locationManager(_ manager: CLLocationManager, didRangeBeacons beacons: [CLBeacon], in region: CLBeaconRegion) {
      //  print(beacons)
        guard let dg = beacons.first?.proximity else { print("error ibeacon"); return }
    
        let bkg:UIColor = {
            switch dg {
            case .unknown:
                self.ba = 0
                self.ibg.append(self.ba)
                return UIColor.white
                
            case .far:
                 self.ba=0
                 self.ibg.append(self.ba)
               return UIColor.white
                
            case .near:
             self.ba = 1
             self.ibg.append(self.ba)
                return UIColor.orange
                
            case .immediate:
                 self.ba = 1
                 self.ibg.append(self.ba)
                return UIColor.green
            @unknown default:
                self.ba=0
                return UIColor.white
                 
            }
        }()
        view.backgroundColor = bkg
    }
    func makeAPhoneCall()  {
        let url: NSURL = URL(string: "TEL://94573344")! as NSURL
        UIApplication.shared.open(url as URL, options: [:], completionHandler: nil)
    }
    
}

